#!/usr/bin/env python

from __future__ import print_function

import roslib; roslib.load_manifest('teleop_twist_keyboard')
import rospy

from geometry_msgs.msg import Twist

import sys, select, termios, tty

msg = """
Reading from the keyboard  and Publishing to Twist!
---------------------------
Moving around:
        w
   a    s    d
   
CTRL-C to quit
"""

moveBindings = {
    'w':(1.0, 0.0),
    's':(-1.0, 0.0),
    'a':(0.0, 1.0),
    'd':(0.0, -1.0)
}

def getKey():
    tty.setraw(sys.stdin.fileno())
    select.select([sys.stdin], [], [], 0)
    key = sys.stdin.read(1)
    termios.tcsetattr(sys.stdin, termios.TCSADRAIN, settings)
    return key


def vels(speed,turn):
    return "currently:\tspeed %s\tturn %s " % (speed,turn)

if __name__=="__main__":
    settings = termios.tcgetattr(sys.stdin)

    pub = rospy.Publisher('/cmd_vel', Twist, queue_size = 1)
    rospy.init_node('teleop_twist_keyboard_node')

    linearX = 0.0
    angularZ = 0.0

    try:
        print(msg)
        while(1):
            key = getKey()
            print(key)
            if key in moveBindings.keys():
                linearX = moveBindings[key][0]
                angularZ = moveBindings[key][1]
            else:
                linearX = 0.0
                angularZ = 0.0
                if (key == '\x03'):
                    break

            twist = Twist()
            twist.linear.x = linearX
            twist.angular.z = angularZ
            pub.publish(twist)

    except Exception as e:
        print(e)

    finally:
        twist = Twist()
        twist.linear.x = 0; twist.linear.y = 0; twist.linear.z = 0
        twist.angular.x = 0; twist.angular.y = 0; twist.angular.z = 0
        pub.publish(twist)

        termios.tcsetattr(sys.stdin, termios.TCSADRAIN, settings)
